#ifdef ANJUTA_MAKEFILE
#include <stdio.h>
#endif

/********************************* Definizioni delle costanti personali **********************************/

 /* Se attivo questo flag la finetra base sparisce
    all'attivarsi delle finetra di modifica e di
    modellazione (e questo risolveva alcui inconvenienti
#define HIDE
 */

#define RVERSN  "Rubrica Italiana v0.37 [it]"
#define AUTHOR  "Autore: Roberto A. Foglietta"
#define EMAIL   "e-mail: robang@libero.it"
#define WEBPAGE "webpage: digilander.iol.it/robang/rubrica"

#define DEFAULT_NEW_FILE_NAME "NewRubrica.rbc"
#define NUM_STATUS_FLAGS  30
#define TXT_LUN          512
#define MAX_N_CAMPI       30
#define MAX_FILENAME_LUN 300
#define MAX_N_NAME      	32000 
#define MAX_FILE_LUN (unsigned long)10485760
#define MAX_RECORD_LUN  1024 

#define X_MIN_BASE_SIZE  480
#define Y_MIN_BASE_SIZE  320

#define ILV_BASE_SIZE  "BaseSize"
#define ILV_MODEM_DEV  "ModemDev"
#define ILV_FIXED_FONT "FixedFont"

#define ON_PAGE  1
#define ON_FIRST 2

#define IF_NEED  0
#define I_FORCE  1

 /* Queste definizioni finiscono dentro allo
    Status di testo: okkio ad re-impostarle */
#define TXT_CLEAN    0
#define TXT_REPLACE  1
#define TXT_APPEND   2

#define IGN_CASE     1
#define CASE_SEN     2
#define REVERSE      4

#define FR_CASE_SEN  0
#define FR_CAMPI     1
#define FR_STRINGHE  2
#define FR_REPLACE   4
#define FR_CASE_IGN  8



 /* Queste constanti sono soggette al cambiamento
    rispetto all'uso di caratteri diversi per questo
    motivo la funzione set_vscroll_windows non 
    utilizzabile in genere ma va sostituita con
    set_scrolled_windows */
#define V_START_LIST  2
#define V_STEP_LIST  14

#define NUM_CAMPI 24
 /*----------------------------------------------*/
#define COD   0	/* Questi valori non     */
#define COG   1	/* possono assolutamente */
#define NOM   2	/* essere cambiati       */
 /*----------------------------------------------*/
#define NIC   3
#define DIT   4
#define IND1  5
#define IND2  6
#define IND3  7
#define CAP   8
#define DTL1  9
#define TEL1 10
#define DTL2 11
#define TEL2 12
#define DTL3 13
#define TEL3 14
#define DTL4 15
#define TEL4 16
#define DTL5 17
#define TEL5 18
#define DTL6 19
#define TEL6 20
#define COM  21
#define EML  22
#define GRP  23

#define S_TESTO    	   1
#define S_RICERCA  	   2
#define S_RUBRICA  	   3
#define S_BUFFER   	   4
 //#define S_CARDS    	   5
#define S_LISTA    	   6
#define S_ORDINE   	   7
 //#define S_SELISTA  	   8
#define S_CAMPI         9
#define S_INIBIT       10
#define S_SELCAMPO     11
#define S_MODIFICA     12
#define S_INFO         13
#define S_CMPMOD       14
#define S_CONFMOD      15
#define S_KEYSHIFT     16
#define S_CRDMOD       17
#define S_AVVRTM       18
#define S_TELEFONO     19
#define S_MODEM        20
#define S_MTERM        21
#define S_BACKUP	      22
#define S_SEQUENZA 	  23
#define S_SEQMOD	      24
#define S_FILEDIALOG   25

#define FILE_APRI       1
#define FILE_SALVA     -1
#define FILE_ESPORTA   -2

#define AVT_APRI        1
#define AVT_BASE	       2
#define AVT_CREAZION    4
#define AVT_MODIFICA	   8
#define AVT_INIBITO    64
#define AVT_DESTROY   128
#define AVT_DESTROYA  129
#define AVT_DESTROYB  130
#define AVT_DESTROYM  132
#define AVT_DESTROYC  136

 /* Per ribaltare l'ordine occorre usare
    il define adeguato pena casini vari */
#define ORD_NOM    1
#define ORD_COG    2
#define ORD_ALF   -1
#define ORD_INV    1
#define ORD_REV   -1

#define ORD_VTEST(c_ord) ((c_ord < 0 && ORD_ALF < 0) || (c_ord > 0 && ORD_ALF > 0) ? ORD_ALF : ORD_INV)

#define KEYB_INVIO 0x0d
#define KEYB_CTRL  0xe3
#define KEYB_I     0x69
#define KEYB_FDOWN 0x54


/********************************* Definizizione delle variabili globali *********************************/

 int LungIntst;
 int Status[NUM_STATUS_FLAGS], OldStatus[NUM_STATUS_FLAGS];
char IndexCampi[MAX_N_CAMPI][5];
char DelCampi[MAX_N_CAMPI], OldDelCampi[MAX_N_CAMPI];
char * Campi[MAX_N_CAMPI]; 
//*ContenutoCampi[MAX_N_CAMPI];
char * OldCampi[MAX_N_CAMPI];
//* OldContenutoCampi[MAX_N_CAMPI];
char * FileBuffer, * Sequenza, * OldSequenza, * SoloNomeFile, * NomeFile,
     * OldSoloNomeFile, * OldNomeFile;
unsigned long FileBufferLun;
GtkWidget *Base, *FileDialog, *Modifica, *Info, *Avvertimento, \
	  *Msg_Errore, *Telefono, *Terminale, *HideWind, *Creazione, \
	  *Esportazione;
GdkFont * FixedFont;
GtkStyle * Base_Style;

struct card  {  //long num;
 		            //char *cod;
		            char *nom;
		            char *cog;
								char *cmp[MAX_N_CAMPI];
	           } *CardCopia, *OldCardCopia;

struct stringa { char * text;
                 int camp;
		             struct stringa * next; 
               } Carta;

struct wind { int w;
              int h; } Wbase, Wedit;

#ifdef PFUNC_H
 /* This is our data identification string to store data in list items  */
 const gchar * list_item_data_key = "list_item_data";
#else
 char InstestazioneCampi[MAX_N_CAMPI][16];
 const gchar * list_item_data_key;
#endif


/********************************* Dichiarazione delle funzioni personali  *******************************/

 long trova_ricerca(const char * strn);
  int get_whats_key(GdkEventKey * event);
  int get_selection_by_code(int code);
 void free_memory(void);
  int carica_rubrica(void);
 void esporta_rubrica_in_csv(FILE *f);
 void modifica_ripristina(void);
 void imposta_rubrica(void);
 void imposta_lista();
 void ordina_lista(void);
 void set_ricerca(const char *strn);
 void reset_lista(void);
 void g_set_window_title (GtkWidget * wind, const char * text);
 void g_set_statusbar (GtkWidget * wind, const char * text);
 void set_lista_item(int k, int inibit);
 void set_vscroll_window(GtkWidget * container, const char * scrolledwindow, int start);
 void set_scrolled_window(GtkWidget * container, const char * scrolledwindow, const char * lista, int mth);
 GtkObject * get_selected_list_item(GtkWidget * container, const char * widget);
 void chiudi_con_modifiche(GtkWidget * padre, int stato);
 void set_sensitive_tools(int force);
 void aggiorna_sequenza_modellata(const char * newseq);
 
 void imposta_lista (void);
 int compare_nom_card(const void *el1, const void *el2);
 int compare_cog_card(const void *el1, const void *el2);
 int compare_inv_nom_card(const void *el1, const void *el2);
 int compare_inv_cog_card(const void *el1, const void *el2);

 
/************************************* Dichiarazione delle macro *****************************************/

#define M_FREE_CARD(rc) {                                               \
	int i;                                                                \
	if(rc) {                                                              \
		for(i = 0; i < MAX_N_CAMPI; i++)                                    \
			M_FREE(rc->cmp[i]);                                               \
		M_FREE(rc);                                                         \
	}                                                                     \
}


#define ANNULLA_MODIFICHE_CAMPI() {                                     \
	M_FREE_CARD(CardCopia)                                                \
  if(Status[S_CRDMOD] > 0)						                                  \
   Status[S_CRDMOD]--;							                                    \
}


#define ANNULLA_MODIFICHE_CREA() {					                            \
  int ii;								                                                \
  if(Status[S_CMPMOD] || Status[S_SEQUENZA] == 2)			                  \
  {									                                                    \
   STATUS_RESTORE();							                                      \
   if(Status[S_SEQUENZA])						                                    \
   {									                                                  \
    if(Sequenza != NULL && OldSequenza != NULL) 			                  \
    {									                                                  \
     M_FREE(Sequenza);							                                    \
     Sequenza = OldSequenza;						                                \
     OldSequenza = NULL;                                                \
    }									                                                  \
    M_FREE_CARD(CardCopia);                                        \
    for(ii = COD; ii < Status[S_CAMPI]; ii++)				                    \
    {									                                                  \
     g_print("\n C[%i]=\"%s\" <- \"%s\"", ii, (Campi[ii]) ? Campi[ii] : "", OldCampi[ii]);     \
     M_FREE(Campi[ii]);                                                 \
     Campi[ii] = OldCampi[ii];                                  	      \
     OldCampi[ii] = NULL;						                                    \
     CardCopia->cmp[ii] = M_STRDUP(Campi[ii]);                         	\
    }                                                                   \
    LungIntst = get_formato_card(Sequenza);				                      \
   }									                                                  \
  }									                                                    \
}


/* N_WIND -deve- essere una variabile puntatore alla finestra da visualizzare */
#define MOSTRA_ON_MOUSE(N_Wind) {                                        \
  gtk_window_set_position( GTK_WINDOW(N_Wind),  GTK_WIN_POS_MOUSE);      \
  gtk_widget_show (N_Wind);                                              \
}


/* Una funzione free leggermente piu` astuta mi evita
   molti  memory leak e molti segmentation default */
#define M_FREE(buffer){                                                 \
  if(buffer != NULL) {                                                  \
   free(buffer);                                                        \
   buffer = NULL;																												\
  }                                                                     \
}

/* Almeno smetto di fare i controlli sui puntatori nulli */
#define M_STRDUP(_s1) ((_s1 != NULL) ? strdup(_s1) : (char *)NULL)

/* CREATE_BASE si occupa di creare la finestra base e di disattivare
   quelle voci di men a cui non vengono riconosciuti dei comandi */
#define CREATE_BASE(_base) {                                            \
   GtkWidget * menu;                                                    \
   _base = create_base ();																							\
   menu = lookup_widget (GTK_WIDGET (_base), "cerca_ovunque");          \
   gtk_widget_set_sensitive (menu, FALSE);                              \
   menu = lookup_widget (GTK_WIDGET (_base), "trova_prossimo");					\
   gtk_widget_set_sensitive (menu, FALSE);                              \
   menu = lookup_widget (GTK_WIDGET (_base), "pulisci");                \
   gtk_widget_set_sensitive (menu, FALSE);                              \
   menu = lookup_widget (GTK_WIDGET (_base), "elimina");                \
   gtk_widget_set_sensitive (menu, FALSE);                              \
   menu = lookup_widget (GTK_WIDGET (_base), "stampaquesto");           \
   gtk_widget_set_sensitive (menu, FALSE);                              \
   set_sensitive_tools(I_FORCE);                                        \
}


/* Questa macro si occupa di visualizzare il contenuto della card
   indicata da num_card nella buffer Lista */
#define STAMPA_CARD(rc) {                                     \
 if(Status[S_RUBRICA] > 0 && rc != NULL)                             \
 {                                                                      \
  stampa_card(rc, Base, "text3");                 		      \
  set_vscroll_window(Base, "scrolledwindow6", 0);                       \
 }                                                                      \
}

                                                                        
#define INIT_STATUS() {							\
  int ii;                                                               \
  for (ii = 0; ii < NUM_STATUS_FLAGS; ii++)                             \
  {									\
   Status[ii] = 0;                                                      \
   OldStatus[ii] = 0;							\
  }									\
  Status[S_ORDINE] = ORD_ALF * ORD_COG;                                 \
  Status[S_MODEM] = -1;                                                 \
  Status[S_MTERM] = 1;                                                  \
  /* Anche DelCampi sono una parte dello stato del sistema */		\
  for(ii = 0;  ii < MAX_N_CAMPI; ii++)					\
   DelCampi[ii] = 0;							\
}


#define INIT_WIN_POINT() {                                              \
  Base      = NULL, FileDialog   = NULL, Modifica   = NULL;             \
  Info      = NULL, Avvertimento = NULL, Msg_Errore = NULL;			        \
  Telefono  = NULL, Terminale    = NULL, HideWind   = NULL;             \
  Creazione = NULL, Esportazione = NULL;                                \
}


#define INIT_RUB_POINT() {                                              \
  int ii;								                                                \
  for (ii = 0; ii < MAX_N_CAMPI; ii++)                                  \
  {                                                                     \
   sprintf(IndexCampi[ii], "%d", ii);                                   \
   Campi[ii]             = NULL;                                        \
   OldCampi[ii]          = NULL;                                        \
   DelCampi[ii]          = 0;                                           \
  }                                                                     \
  Sequenza     = NULL; OldSequenza     = NULL;                          \
  NomeFile     = NULL; SoloNomeFile    = NULL;                          \
	OldNomeFile  = NULL; OldSoloNomeFile = NULL;                          \
  FileBuffer   = NULL; CardCopia       = NULL;                          \
  OldCardCopia = NULL;                                                  \
}


#define RESTART_BASE()	{					        \
  free_memory();                                                        \
  INIT_STATUS();                                        	        \
  Status[S_INIBIT] = S_RUBRICA;                                         \
  gtk_widget_destroy(Base);                                             \
  Status[S_INIBIT] = 0;                                                 \
  CREATE_BASE(Base);                                                    \
  gtk_widget_show (Base);                                               \
}

#define STATUS_BACKUP() {						\
  int ii;								\
  for(ii = 0;  ii < NUM_STATUS_FLAGS; ii++)				\
   OldStatus[ii] = Status[ii];						\
  for(ii = 0;  ii < MAX_N_CAMPI; ii++)					\
   OldDelCampi[ii] = DelCampi[ii];					\
}

#define STATUS_RESTORE() {						\
  int ii;								\
  for(ii = 0;  ii < NUM_STATUS_FLAGS; ii++)				\
   Status[ii] = OldStatus[ii];						\
  for(ii = 0;  ii < MAX_N_CAMPI; ii++)					\
   DelCampi[ii] = OldDelCampi[ii];					\
}

#define DELETED_CAMPI(numcd) {						\
  int ii;								\
  numcd = 0;								\
  for(ii = 0;  ii < Status[S_CAMPI]; ii++)				\
   if(Campi[ii] == NULL) numcd++;					\
} 

   
